from bitarray import bitarray

#
COMMENT = "Comment"
MELODY = "Melody"
DESCRIPTORS = "Descriptors"
MASK = "Mask"
PHRASE = "Phrase"
#
PHRASE_POS = "Phrase position"
BIT_ARRAY = "Phrase Bit Array"
GENERIC = "0000000000000000000000000000000"
GENERIC_1s = "1111111111111111111111111111111"
#
FIRST = "F"
MIDDLE = "M"
LAST = "L"
####
PHRASE_NR = "Phrase number"
#
PH_NR_1 = "1"
PH_NR_2 = "2"
PH_NR_3 = "3"
PH_NR_4 = "4"
PH_NR_5 = "5"
PH_NR_6 = "6"
PH_NR_7 = "7"
PH_NR_8 = "8"
####
PHRASE_LBL = "Phrase label"
#
PH_LBL_A = "A"
PH_LBL_B = "B"
PH_LBL_C = "C"
PH_LBL_D = "D"
PH_LBL_X = "X"
####
PHRASE_SYM = "Phrase symbol"
#
PH_SYM_N = "N"
PH_SYM_I = "I"
PH_SYM_II = "II"
PH_SYM_III = "III"
PH_SYM_P = "P"
PH_SYM_PI = "PI"
PH_SYM_X = "X"
PH_SYM_XI = "XI"
PH_SYM_IX = "IX"
PH_SYM_PX = "PX"
####
PHRASE_CTGEN = "General contour"
#
PH_CTGEN_DESC = "10"
PH_CTGEN_ASC = "01"
PH_CTGEN_H = "11"
####
PHRASE_CTSPEC = "Specific contour"
#
PH_CTSPEC_CVX = "CVX"
PH_CTSPEC_CCV = "CCV"
PH_CTSPEC_ASC = "ASC"
PH_CTSPEC_HA = "HA"
PH_CTSPEC_AH = "AH"
PH_CTSPEC_DESC = "DESC"
PH_CTSPEC_HD = "HD"
PH_CTSPEC_DH = "DH"
PH_CTSPEC_H = "H"
####
PHRASE_HS = "Starting harmony"
PHRASE_HE = "Ending harmony"
#
PH_H_Q = "?"
PH_H_QDT = "?(D/T)"
PH_H_QD = "?(D)"
PH_H_QT = "?(T)"
PH_H_DT = "D/T"
PH_H_D = "D"
PH_H_T = "T"
####
PHRASE_TS = "Time signature"
#
PH_TS_C2 = "Compound Duple"
PH_TS_C3 = "Compound Triple"
PH_TS_O2 = "Other Duple"
PH_TS_O1 = "Other Single"
PH_TS_S2 = "Simple Duple"
PH_TS_S4 = "Simple Quadruple"
PH_TS_S5 = "Simple Quintuple"
PH_TS_S7 = "Simple Septuple"
PH_TS_S3 = "Simple Triple"
####
PHRASE_SCALE = "Tune scale"
#
PH_SC_3 = "3"
PH_SC_4 = "4"
PH_SC_5 = "5"
PH_SC_6 = "6"
PH_SC_7 = "7"
PH_SC_8 = "8"
PH_SC_0 = "None"
####
FEATURES = {
    PHRASE_POS: {
        BIT_ARRAY: bitarray("1100000000000000000000000000000"),
        FIRST: bitarray("1000000000000000000000000000000"),
        MIDDLE: bitarray("1100000000000000000000000000000"),
        LAST: bitarray("0100000000000000000000000000000"),
    },
    PHRASE_NR: {
        BIT_ARRAY: bitarray("0011100000000000000000000000000"),
        PH_NR_1: bitarray("0000000000000000000000000000000"),
        PH_NR_2: bitarray("0000100000000000000000000000000"),
        PH_NR_3: bitarray("0001100000000000000000000000000"),
        PH_NR_4: bitarray("0011100000000000000000000000000"),
        PH_NR_5: bitarray("0010000000000000000000000000000"),
        PH_NR_6: bitarray("0011000000000000000000000000000"),
        PH_NR_7: bitarray("0010100000000000000000000000000"),
        PH_NR_8: bitarray("0001000000000000000000000000000"),
    },
    PHRASE_LBL: {
        BIT_ARRAY: bitarray("0000011100000000000000000000000"),
        PH_LBL_A: bitarray("0000011100000000000000000000000"),
        PH_LBL_B: bitarray("0000000000000000000000000000000"),
        PH_LBL_C: bitarray("0000010000000000000000000000000"),
        PH_LBL_D: bitarray("0000000100000000000000000000000"),
        PH_LBL_X: bitarray("0000010100000000000000000000000"),
    },
    PHRASE_SYM: {
        BIT_ARRAY: bitarray("0000000011110000000000000000000"),
        PH_SYM_N: bitarray("0000000000000000000000000000000"),
        PH_SYM_I: bitarray("0000000000010000000000000000000"),
        PH_SYM_II: bitarray("0000000000110000000000000000000"),
        PH_SYM_III: bitarray("0000000001110000000000000000000"),
        PH_SYM_P: bitarray("0000000010100000000000000000000"),
        PH_SYM_PI: bitarray("0000000010110000000000000000000"),
        PH_SYM_X: bitarray("0000000010010000000000000000000"),
        PH_SYM_XI: bitarray("0000000011010000000000000000000"),
        PH_SYM_IX: bitarray("0000000011110000000000000000000"),
        PH_SYM_PX: bitarray("0000000001100000000000000000000"),
    },
    PHRASE_CTGEN: {
        BIT_ARRAY: bitarray("0000000000001100000000000000000"),
        PH_CTGEN_DESC: bitarray("0000000000001000000000000000000"),
        PH_CTGEN_ASC: bitarray("0000000000000100000000000000000"),
        PH_CTGEN_H: bitarray("0000000000001100000000000000000"),
    },
    PHRASE_CTSPEC: {
        BIT_ARRAY: bitarray("0000000000000011110000000000000"),
        PH_CTSPEC_CVX: bitarray("0000000000000010010000000000000"),
        PH_CTSPEC_CCV: bitarray("0000000000000001100000000000000"),
        PH_CTSPEC_ASC: bitarray("0000000000000011110000000000000"),
        PH_CTSPEC_HA: bitarray("0000000000000010000000000000000"),
        PH_CTSPEC_AH: bitarray("0000000000000011000000000000000"),
        PH_CTSPEC_DESC: bitarray("0000000000000000000000000000000"),
        PH_CTSPEC_HD: bitarray("0000000000000001110000000000000"),
        PH_CTSPEC_DH: bitarray("0000000000000000110000000000000"),
        PH_CTSPEC_H: bitarray("0000000000000010100000000000000"),
    },
    PHRASE_HS: {
        BIT_ARRAY: bitarray("0000000000000000001110000000000"),
        PH_H_Q: bitarray("0000000000000000001010000000000"),
        PH_H_QDT: bitarray("0000000000000000000100000000000"),
        PH_H_QD: bitarray("0000000000000000000110000000000"),
        PH_H_QT: bitarray("0000000000000000001000000000000"),
        PH_H_DT: bitarray("0000000000000000001100000000000"),
        PH_H_D: bitarray("0000000000000000000000000000000"),
        PH_H_T: bitarray("0000000000000000001110000000000"),
    },
    PHRASE_HE: {
        BIT_ARRAY: bitarray("0000000000000000000001110000000"),
        PH_H_Q: bitarray("0000000000000000000001010000000"),
        PH_H_QDT: bitarray("0000000000000000000000100000000"),
        PH_H_QD: bitarray("0000000000000000000000110000000"),
        PH_H_QT: bitarray("0000000000000000000001000000000"),
        PH_H_DT: bitarray("0000000000000000000001100000000"),
        PH_H_D: bitarray("0000000000000000000000000000000"),
        PH_H_T: bitarray("0000000000000000000001110000000"),
    },
    PHRASE_TS: {
        BIT_ARRAY: bitarray("0000000000000000000000001111000"),
        PH_TS_C2: bitarray("0000000000000000000000001100000"),
        PH_TS_C3: bitarray("0000000000000000000000001110000"),
        PH_TS_O2: bitarray("0000000000000000000000001001000"),
        PH_TS_O1: bitarray("0000000000000000000000001000000"),
        PH_TS_S2: bitarray("0000000000000000000000000110000"),
        PH_TS_S4: bitarray("0000000000000000000000001111000"),
        PH_TS_S5: bitarray("0000000000000000000000001011000"),
        PH_TS_S7: bitarray("0000000000000000000000001010000"),
        PH_TS_S3: bitarray("0000000000000000000000000111000"),
    },
    PHRASE_SCALE: {
        BIT_ARRAY: bitarray("0000000000000000000000000000111"),
        PH_SC_3: bitarray("0000000000000000000000000000111"),
        PH_SC_4: bitarray("0000000000000000000000000000110"),
        PH_SC_5: bitarray("0000000000000000000000000000100"),
        PH_SC_6: bitarray("0000000000000000000000000000101"),
        PH_SC_7: bitarray("0000000000000000000000000000011"),
        PH_SC_8: bitarray("0000000000000000000000000000010"),
        PH_SC_0: bitarray("0000000000000000000000000000000"),
    },
}
